regina::LayeredSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a layered solid torus in a triangulation. More...

`#include <subcomplex/layeredsolidtorus.h>`

Inheritance diagram for regina::LayeredSolidTorus:

## Public Member Functions

LayeredSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
size_t | size () const
| Returns the number of tetrahedra in this layered solid torus. More...
Tetrahedron< 3 > * | base () const
| Returns the tetrahedron that is glued to itself at the base of this layered solid torus. More...
int | baseEdge (int group, int index) const
| Returns the requested edge of the base tetrahedron belonging to the given group. More...
int | baseEdgeGroup (int edge) const
| Returns the group that the given edge of the base tetrahedron belongs to. More...
int | baseFace (int index) const
| Returns one of the two faces of the base tetrahedron that are glued to each other. More...
Tetrahedron< 3 > * | topLevel () const
| Returns the top level tetrahedron in this layered solid torus. More...
unsigned long | meridinalCuts (int group) const
| Returns the number of times the meridinal disc of the torus cuts the top level tetrahedron edges in the given group. More...
int | topEdge (int group, int index) const
| Returns the requested edge of the top level tetrahedron belonging to the given group. More...
int | topEdgeGroup (int edge) const
| Returns the group that the given edge of the top level tetrahedron belongs to. More...
int | topFace (int index) const
| Returns one of the two faces of the top level tetrahedron that form the boundary of this layered solid torus. More...
Triangulation< 3 > * | flatten (const Triangulation< 3 > *original, int mobiusBandBdry) const
| Flattens this layered solid torus to a Mobius band. More...
void | transform (const Triangulation< 3 > *originalTri, const Isomorphism< 3 > *iso, Triangulation< 3 > *newTri)
| Adjusts the details of this layered solid torus according to the given isomorphism between triangulations. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static LayeredSolidTorus * | formsLayeredSolidTorusBase (Tetrahedron< 3 > *tet)
| Determines if the given tetrahedron forms the base of a layered solid torus within a triangulation. More...
static LayeredSolidTorus * | formsLayeredSolidTorusTop (Tetrahedron< 3 > *tet, unsigned topFace1, unsigned topFace2)
| Determines if the given tetrahedron forms the top level tetrahedron of a layered solid torus, with the two given faces of this tetrahedron representing the boundary of the layered solid torus. More...
static LayeredSolidTorus * | isLayeredSolidTorus (Component< 3 > *comp)
| Determines if the given triangulation component forms a layered solid torus in its entirity. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Represents a layered solid torus in a triangulation.

A layered solid torus must contain at least one tetrahedron.

Note that this class only represents layered solid tori with a (3,2,1) at their base. Thus triangulations that begin with a degenerate (2,1,1) mobius strip and layer over the mobius strip boundary (including the minimal (1,1,0) triangulation) are not described by this class.

All optional StandardTriangulation routines are implemented for this class.

## Member Function Documentation

## base()

Tetrahedron< 3 > * regina::LayeredSolidTorus::base | ( |  | ) | const

inline

Returns the tetrahedron that is glued to itself at the base of this layered solid torus.

Returns
  the base tetrahedron.

## baseEdge()

int regina::LayeredSolidTorus::baseEdge | ( | int | group,
|  | int | index
| ) |  | const

inline

Returns the requested edge of the base tetrahedron belonging to the given group.

The layering identifies the six edges of the base tetrahedron into a group of three, a group of two and a single unidentified edge; these are referred to as groups 3, 2 and 1 respectively.

Note that `baseEdgeGroup(baseEdge(group, index)) == group` for all values of `group` and `index`.

Edges `baseEdge(2,0)` and `baseEdge(3,0)` will both belong to face `baseFace(0)`. Edges `baseEdge(2,1)` and `baseEdge(3,2)` will both belong to face `baseFace(1)`.

Parameters

  group | the group that the requested edge should belong to; this must be 1, 2 or 3.
  index | the index within the given group of the requested edge; this must be between 0 and group-1 inclusive. Note that in group 3 the edge at index 1 is adjacent to both the edges at indexes 0 and 2.

Returns
  the edge number in the base tetrahedron of the requested edge; this will be between 0 and 5 inclusive.

## baseEdgeGroup()

int regina::LayeredSolidTorus::baseEdgeGroup | ( | int | edge | ) | const

inline

Returns the group that the given edge of the base tetrahedron belongs to.

See baseEdge() for further details about groups.

Note that `baseEdgeGroup(baseEdge(group, index)) == group` for all values of `group` and `index`.

Parameters

  edge | the edge number in the base tetrahedron of the given edge; this must be between 0 and 5 inclusive.

Returns
  the group to which the given edge belongs; this will be 1, 2 or 3.

## baseFace()

int regina::LayeredSolidTorus::baseFace | ( | int | index | ) | const

inline

Returns one of the two faces of the base tetrahedron that are glued to each other.

Parameters

  index | specifies which of the two faces to return; this must be 0 or 1.

Returns
  the requested face number in the base tetrahedron; this will be between 0 and 3 inclusive.

## clone()

LayeredSolidTorus* regina::LayeredSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## flatten()

Triangulation<3>* regina::LayeredSolidTorus::flatten | ( | const Triangulation< 3 > * | original,
|  | int | mobiusBandBdry
| ) |  | const

Flattens this layered solid torus to a Mobius band.

A newly created modified triangulation is returned; the original triangulation is unchanged.

Note that there are three different ways in which this layered solid torus can be flattened, corresponding to the three different edges of the boundary torus that could become the boundary edge of the new Mobius band.

Parameters

  original | the triangulation containing this layered solid torus; this triangulation will not be changed.
  mobiusBandBdry | the edge group on the boundary of this layered solid torus that will become the boundary of the new Mobius band (the remaining edge groups will become internal edges of the new Mobius band). This must be 0, 1 or 2. See topEdge() for further details about edge groups.

Returns
  a newly created triangulation in which this layered solid torus has been flattened to a Mobius band.

## formsLayeredSolidTorusBase()

static LayeredSolidTorus* regina::LayeredSolidTorus::formsLayeredSolidTorusBase | ( | Tetrahedron< 3 > * | tet | ) |

static

Determines if the given tetrahedron forms the base of a layered solid torus within a triangulation.

The torus need not be the entire triangulation; the top level tetrahedron of the torus may be glued to something else (or to itself).

Note that the base tetrahedron of a layered solid torus is the tetrahedron furthest from the boundary of the torus, i.e. the tetrahedron glued to itself with a twist.

Parameters

  tet | the tetrahedron to examine as a potential base.

Returns
  a newly created structure containing details of the layered solid torus, or `null` if the given tetrahedron is not the base of a layered solid torus.

## formsLayeredSolidTorusTop()

static LayeredSolidTorus* regina::LayeredSolidTorus::formsLayeredSolidTorusTop | ( | Tetrahedron< 3 > * | tet,
|  | unsigned | topFace1,
|  | unsigned | topFace2
| ) |  |

static

Determines if the given tetrahedron forms the top level tetrahedron of a layered solid torus, with the two given faces of this tetrahedron representing the boundary of the layered solid torus.

Note that the two given faces need not be boundary triangles in the overall triangulation. That is, the layered solid torus may be a subcomplex of some larger triangulation. For example, the two given faces may be joined to some other tetrahedra outside the layered solid torus or they may be joined to each other. In fact, they may even extend this smaller layered solid torus to a larger layered solid torus.

Parameters

  tet | the tetrahedron to examine as a potential top level of a layered solid torus.
  topFace1 | the face number of the given tetrahedron that should represent the first boundary triangle of the layered solid torus. This should be between 0 and 3 inclusive.
  topFace2 | the face number of the given tetrahedron that should represent the second boundary triangle of the layered solid torus. This should be between 0 and 3 inclusive, and should not be equal to topFace1.

Returns
  a newly created structure containing details of the layered solid torus, or `null` if the given tetrahedron with its two faces do not form the top level of a layered solid torus.

## homology()

AbelianGroup* regina::LayeredSolidTorus::homology | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::StandardTriangulation.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## isLayeredSolidTorus()

static LayeredSolidTorus* regina::LayeredSolidTorus::isLayeredSolidTorus | ( | Component< 3 > * | comp | ) |

static

Determines if the given triangulation component forms a layered solid torus in its entirity.

Note that, unlike formsLayeredSolidTorusBase(), this routine tests for a component that is a layered solid torus with no additional tetrahedra or gluings. That is, the two boundary triangles of the layered solid torus must in fact be boundary triangles of the component.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the layered solid torus, or `null` if the given component is not a layered solid torus.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## manifold()

Manifold* regina::LayeredSolidTorus::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## meridinalCuts()

unsigned long regina::LayeredSolidTorus::meridinalCuts | ( | int | group | ) | const

inline

Returns the number of times the meridinal disc of the torus cuts the top level tetrahedron edges in the given group.

See topEdge() for further details about groups.

Parameters

  group | the given edge group; this must be 0, 1 or 2.

Returns
  the number of times the meridinal disc cuts the edges in the given group.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## size()

size_t regina::LayeredSolidTorus::size | ( |  | ) | const

inline

Returns the number of tetrahedra in this layered solid torus.

Returns
  the number of tetrahedra.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## topEdge()

int regina::LayeredSolidTorus::topEdge | ( | int | group,
|  | int | index
| ) |  | const

inline

Returns the requested edge of the top level tetrahedron belonging to the given group.

The layering reduces five of the top level tetrahedron edges to three boundary edges of the solid torus; this divides the five initial edges into groups of size two, two and one.

Group 0 represents the boundary edge that the meridinal disc cuts fewest times. Group 2 represents the boundary edge that the meridinal disc cuts most times. Group 1 is in the middle.

Note that `topEdgeGroup(topEdge(group, index)) == group` for all values of `group` and `index` that actually correspond to an edge.

Edges `topEdge(group, 0)` will all belong to face `topFace(0)`. Edges `topEdge(group, 1)` (if they exist) will all belong to face `topFace(1)`.

Parameters

  group | the group that the requested edge should belong to; this must be 0, 1 or 2.
  index | the index within the given group of the requested edge; this must be 0 or 1. Note that one of the groups only contains one tetrahedron edge, in which case this edge will be stored at index 0.

Returns
  the edge number in the top level tetrahedron of the requested edge (between 0 and 5 inclusive), or -1 if there is no such edge (only possible if the given group was the group of size one and the given index was 1).

## topEdgeGroup()

int regina::LayeredSolidTorus::topEdgeGroup | ( | int | edge | ) | const

inline

Returns the group that the given edge of the top level tetrahedron belongs to.

See topEdge() for further details about groups.

Note that `topEdgeGroup(topEdge(group, index)) == group` for all values of `group` and `index` that actually correspond to an edge.

Parameters

  edge | the edge number in the top level tetrahedron of the given edge; this must be between 0 and 5 inclusive.

Returns
  the group to which the given edge belongs (0, 1 or 2), or -1 if this edge does not belong to any group (only possible if this is the unique edge in the top tetrahedron not on the torus boundary).

## topFace()

int regina::LayeredSolidTorus::topFace | ( | int | index | ) | const

inline

Returns one of the two faces of the top level tetrahedron that form the boundary of this layered solid torus.

Parameters

  index | specifies which of the two faces to return; this must be 0 or 1.

Returns
  the requested face number in the top level tetrahedron; this will be between 0 and 3 inclusive.

## topLevel()

Tetrahedron< 3 > * regina::LayeredSolidTorus::topLevel | ( |  | ) | const

inline

Returns the top level tetrahedron in this layered solid torus.

This is the tetrahedron that would be on the boundary of the torus if the torus were the entire manifold.

Returns
  the top level tetrahedron.

## transform()

void regina::LayeredSolidTorus::transform | ( | const Triangulation< 3 > * | originalTri,
|  | const Isomorphism< 3 > * | iso,
|  | Triangulation< 3 > * | newTri
| ) |  |

Adjusts the details of this layered solid torus according to the given isomorphism between triangulations.

The given isomorphism must describe a mapping from originalTri to newTri, and this layered solid torus must currently refer to tetrahedra in originalTri. After this routine is called this structure will instead refer to the corresponding tetrahedra in newTri (with changes in vertex/face numbering also accounted for).

Precondition
  This layered solid torus currently refers to tetrahedra in originalTri, and iso describes a mapping from originalTri to newTri.

Parameters

  originalTri | the triangulation currently referenced by this layered solid torus.
  iso | the mapping from originalTri to newTri.
  newTri | the triangulation to be referenced by the updated layered solid torus.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream & regina::LayeredSolidTorus::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream & regina::LayeredSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::LayeredSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::StandardTriangulation.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- subcomplex/layeredsolidtorus.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).